=== debian/changelog ===
olsrd (0.6.6.1-1) unstable; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Fri, 25 Oct 2013 20:01:53 +0200

olsrd (0.6.5.2-1~) experimental; urgency=low

  * New upstream release
  * remove patches that have been included or obsoleted upstream
  * update build process based on upstream changes

 -- Hans-Christoph Steiner <hans@eds.org>  Mon, 01 Apr 2013 22:39:25 -0700

olsrd (0.6.3-6) unstable; urgency=low

  * include upstream fix for brokenness on amd64 (Closes: #704025)

 -- Hans-Christoph Steiner <hans@eds.org>  Wed, 27 Mar 2013 14:46:23 -0700
